local healthFrameWidth = 200;
local healthFrameHeight = 5;
local healthFrame = CreateFrame("Frame","health",UIParent)
healthFrame.texture = healthFrame:CreateTexture(nil, "BACKGROUND")
healthFrame.texture:SetAllPoints(true)
healthFrame.texture:SetColorTexture(0.0, 0.0, 0.0, 1.0)
healthFrame:SetWidth(healthFrameWidth)
healthFrame:SetHeight(healthFrameHeight) 
healthFrame:SetPoint("CENTER",0,-100)
healthFrame:Show()

local healthFrameTaken = CreateFrame("Frame", "healthTaken", healthFrame);
healthFrameTaken.texture = healthFrameTaken:CreateTexture(nil, "BACKGROUND")
healthFrameTaken.texture:SetAllPoints(true)
healthFrameTaken.texture:SetColorTexture(1.0, 0.0, 0.0, 1.0)
healthFrameTaken:SetWidth(healthFrameWidth)
healthFrameTaken:SetHeight(healthFrameHeight)
healthFrameTaken:SetPoint("TOPLEFT",0,0)
healthFrameTaken:SetFrameStrata("MEDIUM")
healthFrameTaken:Show()

local healthFrameCurrent = CreateFrame("Frame", "healthCurrent", healthFrame);
healthFrameCurrent.texture = healthFrameCurrent:CreateTexture(nil, "BACKGROUND")
healthFrameCurrent.texture:SetAllPoints(true)
healthFrameCurrent.texture:SetColorTexture(0.0, 1.0, 0.0, 1.0)
healthFrameCurrent:SetWidth(healthFrameWidth)
healthFrameCurrent:SetHeight(healthFrameHeight) 
healthFrameCurrent:SetPoint("TOPLEFT",0,0)
healthFrameCurrent:SetFrameStrata("HIGH")
healthFrameCurrent:Show()

local healthHistory = {}

healthFrame:SetScript("OnUpdate", function(self, sinceLastUpdate) healthFrame:onUpdate(sinceLastUpdate); end);

function getCurrentHealthPercent()
    return UnitHealth("player")/UnitHealthMax("player")
end

function healthFrame:onUpdate(sinceLastUpdate)
    local now = time();
    local currentHealth =  getCurrentHealthPercent();
    if(healthHistory[now] == nil or healthHistory[now] > currentHealth) then
        healthHistory[now] = currentHealth
    end
    updateFrames()    
end

function updateFrames()
    local now = time()
    local damage = 0
    for i=now-5, now do
        if healthHistory[i+1] ~= nil and healthHistory[i] ~= nil and (healthHistory[i+1] < healthHistory[i])
        then
            damage = damage + (healthHistory[i] - healthHistory[i+1])
        end
    end    

    healthFrameCurrent:SetWidth(healthFrameWidth * getCurrentHealthPercent())
    healthFrameTaken:SetWidth(healthFrameWidth * (getCurrentHealthPercent() + damage))
end

print("Zepmix Damage Taken - This is a sperimental addon")